#include<bits/stdc++.h>
using namespace std;
int N,A,B,AB,O,a,b,ab,o,resenje[10][10];
string vrstakrvi;
int kol,kolicina[10],nesortkolicina;
/*
Funkcija za proveru (manje redova)

popravi kod


za izlazak iz funkcije
exit(0)
*/

int main(){
    cin>>N;
    cin>>O>>A>>B>>AB;
    for(int i = 1;i<=N;i++){
        cin>>vrstakrvi>>kol;
        if(vrstakrvi=="O")kolicina[1]+=kol;
        if(vrstakrvi=="A")kolicina[2]+=kol;
        if(vrstakrvi=="B")kolicina[3]+=kol;
        if(vrstakrvi=="AB")kolicina[4]+=kol;
    }

    //================================

    for(int i=1;i<=O;i++){
        if(kolicina[1]<=o){
        o--;
        kolicina[1]--;
        resenje[i][1]++;
    }
      else {cout<<"nemoguce"<<endl; return 0;}
  }

    //================================

  for(int i=1;i<=A;i++){
    if(kolicina[2]+kolicina[1]<=a){
      if(a!=0){
        a--;
        kolicina[2]--;
        resenje[i][2]++;
      }
      else{
        if(o!=0){
          o--;
          kolicina[1]--;
          resenje[i][1]++;
        }
      }
    }
      else {cout<<"nemoguce"<<endl; return 0;}
  }
    //================================

    for(int i=1;i<=B;i++){
    if(kolicina[3]+kolicina[1]<=b){
      if(b!=0){
        b--;
        kolicina[3]--;
        resenje[i][3]++;
      }
      else{
        if(o!=0){
          o--;
          kolicina[1]--;
          resenje[i][1]++;
        }
      }
    }
      else {cout<<"nemoguce"<<endl; return 0;}
  }

  //================================

    for(int i=1;i<=AB;i++){
    if(kolicina[1]+kolicina[2]+kolicina[3]+kolicina[4]<=ab){
      if(ab!=0){
        ab--;
        kolicina[4]--;
        resenje[i][4]++;
      }
      else{
        if(a!=0){
          a--;
          kolicina[2]--;
          resenje[i][2]++;
        }
        else{
          if(b!=0){
            b--;
            kolicina[3]--;
            resenje[i][3]++;
          }
          else{
            if(o!=0){
              o--;
              kolicina[1]--;
              resenje[i][1]++;
            }
          }
        }
      }
    }
      else {cout<<"nemoguce"<<endl;return 0;}
  }
  cout<<"moguce"<<endl;
  for(int i = 1;i<=4;i++){
    for(int j = 1;j<=4;j++){
      cout<<resenje[i][j]<<" ";
    }
    cout<<endl;
  }


  return 0;
}